Index: /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2594)
@@ -98,5 +98,5 @@
     REAL,SAVE           :: bl95_b0_omp, bl95_b1_omp
     REAL,SAVE           :: freq_ISCCP_omp, ecrit_ISCCP_omp
-    REAL,SAVE           :: freq_COSP_omp
+    REAL,SAVE           :: freq_COSP_omp, freq_AIRS_omp 
     real,SAVE           :: fact_cldcon_omp, facttemps_omp,ratqsbas_omp
     real,SAVE           :: tau_cld_cv_omp, coefw_cld_cv_omp
@@ -165,4 +165,5 @@
     INTEGER,SAVE :: iflag_ice_thermo_omp
     INTEGER,SAVE :: iflag_t_glace_omp
+    INTEGER,SAVE :: iflag_cloudth_vert_omp
     REAL,SAVE :: rad_froid_omp, rad_chau1_omp, rad_chau2_omp
     REAL,SAVE :: t_glace_min_omp, t_glace_max_omp
@@ -178,4 +179,5 @@
     REAL,SAVE :: cdmmax_omp,cdhmax_omp,ksta_omp,ksta_ter_omp,f_ri_cd_min_omp
     LOGICAL,SAVE :: ok_kzmin_omp
+    REAL, SAVE   :: pbl_lmixmin_alpha_omp
     REAL, SAVE ::  fmagic_omp, pmagic_omp
     INTEGER,SAVE :: iflag_pbl_omp,lev_histhf_omp,lev_histday_omp,lev_histmth_omp
@@ -188,5 +190,5 @@
     REAL, SAVE :: freq_outNMC_omp(3), freq_calNMC_omp(3)
     CHARACTER*4, SAVE :: type_run_omp
-    LOGICAL,SAVE :: ok_cosp_omp
+    LOGICAL,SAVE :: ok_cosp_omp, ok_airs_omp
     LOGICAL,SAVE :: ok_mensuelCOSP_omp,ok_journeCOSP_omp,ok_hfCOSP_omp
     REAL,SAVE :: lonmin_ins_omp, lonmax_ins_omp, latmin_ins_omp, latmax_ins_omp
@@ -460,4 +462,13 @@
     call getin('freq_COSP', freq_COSP_omp)
 
+    !Config Key  = freq_AIRS
+    !Config Desc = Frequence d'appel du simulateur AIRS en secondes;
+    !              par defaut 10800, i.e. 3 heures
+    !Config Def  = 10800.
+    !Config Help = Used in ini_histdayAIRS.h
+    !
+    freq_AIRS_omp = 10800.
+    call getin('freq_AIRS', freq_AIRS_omp)
+
     !
     !Config Key  = ip_ebil_phy
@@ -1161,4 +1172,13 @@
 
     !
+    !Config Key  = iflag_cloudth_vert
+    !Config Desc =  
+    !Config Def  = 0
+    !Config Help = 
+    !
+    iflag_cloudth_vert_omp = 0
+    call getin('iflag_cloudth_vert',iflag_cloudth_vert_omp)
+
+    !
     !Config Key  = iflag_ice_thermo
     !Config Desc =  
@@ -1259,4 +1279,8 @@
     ok_kzmin_omp = .true.
     call getin('ok_kzmin',ok_kzmin_omp)
+
+    pbl_lmixmin_alpha_omp=0.0
+    call getin('pbl_lmixmin_alpha',pbl_lmixmin_alpha_omp)
+
 
     !
@@ -1594,4 +1618,13 @@
     ok_cosp_omp = .false.
     call getin('ok_cosp',ok_cosp_omp)
+
+    !
+    !Config Key  = ok_airs
+    !Config Desc =
+    !Config Def  = .false.
+    !Config Help =
+    !
+    ok_airs_omp = .false.
+    call getin('ok_airs',ok_airs_omp)
 
     !
@@ -2044,4 +2077,5 @@
     exposant_glace = exposant_glace_omp
     iflag_t_glace = iflag_t_glace_omp
+    iflag_cloudth_vert=iflag_cloudth_vert_omp
     iflag_ice_thermo = iflag_ice_thermo_omp
     rei_min = rei_min_omp
@@ -2055,4 +2089,5 @@
     f_ri_cd_min = f_ri_cd_min_omp
     ok_kzmin = ok_kzmin_omp
+    pbl_lmixmin_alpha=pbl_lmixmin_alpha_omp
     fmagic = fmagic_omp
     pmagic = pmagic_omp
@@ -2094,4 +2129,5 @@
     ecrit_ISCCP = ecrit_ISCCP_omp
     freq_COSP = freq_COSP_omp
+    freq_AIRS = freq_AIRS_omp
     ok_ade = ok_ade_omp
     ok_aie = ok_aie_omp
@@ -2144,4 +2180,6 @@
     type_run = type_run_omp
     ok_cosp = ok_cosp_omp
+    ok_airs = ok_airs_omp
+
     ok_mensuelCOSP = ok_mensuelCOSP_omp
     ok_journeCOSP = ok_journeCOSP_omp
@@ -2291,4 +2329,5 @@
     write(lunout,*)' Frequence appel simulateur ISCCP, ecrit_ISCCP =', ecrit_ISCCP
     write(lunout,*)' Frequence appel simulateur COSP, freq_COSP =', freq_COSP
+    write(lunout,*)' Frequence appel simulateur AIRS, freq_AIRS =', freq_AIRS
     write(lunout,*)' Sortie bilan d''energie, ip_ebil_phy =', ip_ebil_phy
     write(lunout,*)' Excentricite = ',R_ecc
@@ -2361,4 +2400,5 @@
     write(lunout,*)' exposant_glace = ',exposant_glace
     write(lunout,*)' iflag_t_glace = ',iflag_t_glace
+    write(lunout,*)' iflag_cloudth_vert = ',iflag_cloudth_vert
     write(lunout,*)' iflag_ice_thermo = ',iflag_ice_thermo
     write(lunout,*)' rei_min = ',rei_min
@@ -2371,4 +2411,5 @@
     write(lunout,*)' f_ri_cd_min = ',f_ri_cd_min 
     write(lunout,*)' ok_kzmin = ',ok_kzmin 
+    write(lunout,*)' pbl_lmixmin_alpha = ',pbl_lmixmin_alpha
     write(lunout,*)' fmagic = ',fmagic
     write(lunout,*)' pmagic = ',pmagic
@@ -2404,4 +2445,6 @@
     write(lunout,*)' type_run = ',type_run 
     write(lunout,*)' ok_cosp = ',ok_cosp
+    write(lunout,*)' ok_airs = ',ok_airs
+
     write(lunout,*)' ok_mensuelCOSP = ',ok_mensuelCOSP
     write(lunout,*)' ok_journeCOSP = ',ok_journeCOSP
Index: /LMDZ5/branches/testing/libf/phylmd/cosp/cosp_constants.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cosp/cosp_constants.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/cosp/cosp_constants.F90	(revision 2594)
@@ -108,5 +108,6 @@
                    -31.5,-28.5,-25.5,-22.5,-19.5,-16.5,-13.5,-10.5, -7.5, -4.5, &
                     -1.5,  1.5,  4.5,  7.5, 10.5, 13.5, 16.5, 19.5, 22.5, 25.5/)
-    real,parameter,dimension(2,LIDAR_NTEMP) :: LIDAR_PHASE_TEMP_BNDS=reshape(source=(/-273.15,-90.,-90.,-87.,-87.,-84.,-84.,-81.,-81.,-78., &
+    real,parameter,dimension(2,LIDAR_NTEMP) :: LIDAR_PHASE_TEMP_BNDS=reshape(source=&
+                    (/-273.15,-90.,-90.,-87.,-87.,-84.,-84.,-81.,-81.,-78., &
                    -78.,-75.,-75.,-72.,-72.,-69.,-69.,-66.,-66.,-63., &
                    -63.,-60.,-60.,-57.,-57.,-54.,-54.,-51.,-51.,-48., &
Index: /LMDZ5/branches/testing/libf/phylmd/cosp/cosp_output_write_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cosp/cosp_output_write_mod.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/cosp/cosp_output_write_mod.F90	(revision 2594)
@@ -322,4 +322,7 @@
     if(modis%Cloud_Particle_Size_Water_Mean(ip).eq.R_UNDEF)then
        modis%Cloud_Particle_Size_Water_Mean(ip)=Cosp_fill_value
+    endif
+    if(modis%Cloud_Particle_Size_Ice_Mean(ip).eq.R_UNDEF)then
+       modis%Cloud_Particle_Size_Ice_Mean(ip)=Cosp_fill_value
     endif
     if(modis%Cloud_Top_Pressure_Total_Mean(ip).eq.R_UNDEF)then
Index: /LMDZ5/branches/testing/libf/phylmd/cv3_routines.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv3_routines.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/cv3_routines.F90	(revision 2594)
@@ -3860,4 +3860,5 @@
       sigd(il) = sigd(il)/alpha_qpos(il)
       precip(il) = precip(il)/alpha_qpos(il)
+      cbmf(il) = cbmf(il)/alpha_qpos(il)
     END IF
   END DO
Index: /LMDZ5/branches/testing/libf/phylmd/dyn1d/1DUTILS.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/dyn1d/1DUTILS.h	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/dyn1d/1DUTILS.h	(revision 2594)
@@ -3236,4 +3236,6 @@
      &           thlpcar(nlev_max),tracer(nlev_max,ntrac)
 
+        real height1(nlev_max)
+
         integer, parameter :: ilesfile=1
         integer :: ierr,k,itrac,nt1,nt2
@@ -3245,5 +3247,5 @@
         read (ilesfile,*) kmax
         do k=1,kmax
-          read (ilesfile,*) height(k),thlprof(k),qtprof (k),               &
+          read (ilesfile,*) height1(k),thlprof(k),qtprof (k),               &
      &                      uprof (k),vprof  (k),e12prof(k)
         enddo
@@ -3261,4 +3263,11 @@
           read (ilesfile,*) height(k),ugprof(k),vgprof(k),wfls(k),         &
      &                      dqtdxls(k),dqtdyls(k),dqtdtls(k),thlpcar(k)
+        end do
+        do k=1,kmax
+          if (height(k) .ne. height1(k)) then
+            print *, 'fichiers prof.inp et lscale.inp incompatibles :'
+            print *, 'les niveaux different : ',k,height1(k), height(k)
+            stop
+          endif
         end do
         close(ilesfile)
Index: /LMDZ5/branches/testing/libf/phylmd/dyn1d/1D_interp_cases.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/dyn1d/1D_interp_cases.h	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/dyn1d/1D_interp_cases.h	(revision 2594)
@@ -2,4 +2,13 @@
 ! $Id$
 !
+!---------------------------------------------------------------------
+! Forcing_LES case: constant dq_dyn
+!---------------------------------------------------------------------
+      if (forcing_LES) then
+        DO l = 1,llm
+          d_q_adv(l,1) = dq_dyn(l,1)
+        ENDDO
+      endif ! forcing_LES
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !---------------------------------------------------------------------
 ! Interpolation forcing in time and onto model levels
Index: /LMDZ5/branches/testing/libf/phylmd/dyn1d/lmdz1d.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/dyn1d/lmdz1d.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/dyn1d/lmdz1d.F90	(revision 2594)
@@ -33,5 +33,5 @@
    USE mod_1D_cases_read
    USE mod_1D_amma_read
-   USE print_control_mod, ONLY: prt_level
+   USE print_control_mod, ONLY: lunout, prt_level
    USE iniphysiq_mod, ONLY: iniphysiq
    USE mod_const_mpi, ONLY: comm_lmdz
@@ -54,4 +54,5 @@
 #include "fcg_gcssold.h"
 !!!#include "fbforcing.h"
+#include "compbl.h"
 
 !=====================================================================
@@ -242,4 +243,5 @@
 !---------------------------------------------------------------------
       integer :: k,l,i,it=1,mxcalc
+      integer :: nsrf
       integer jcode
       INTEGER read_climoz 
@@ -738,6 +740,14 @@
         t_ancien(1,:)=temp(:)
         q_ancien(1,:)=q(:,1)
-        pbl_tke(:,:,:)=1.e-8
-        wake_delta_pbl_tke(:,:,:)=0.
+!jyg<
+!!        pbl_tke(:,:,:)=1.e-8
+        pbl_tke(:,:,:)=0.
+        pbl_tke(:,2,:)=1.e-2
+        PRINT *, ' pbl_tke dans lmdz1d '
+       DO nsrf = 1,4
+         PRINT *,'pbl_tke(1,:,',nsrf,') ',pbl_tke(1,:,nsrf)
+       ENDDO
+
+!>jyg
 
         rain_fall=0.
@@ -762,5 +772,5 @@
         wake_deltaq = 0.
         wake_deltat = 0.
-        wake_delta_pbl_TKE = 0.
+        wake_delta_pbl_TKE(:,:,:) = 0.
         delta_tsurf = 0.
         wake_fip = 0.
@@ -791,7 +801,12 @@
 ! run_off_lic_0,pbl_tke(:,1:klev,nsrf), zmax0,f0,sig1,w01
 ! wake_deltat,wake_deltaq,wake_s,wake_cstar,wake_fip,wake_delta_pbl_tke(:,1:klev,nsrf)
+!
+! NB2: The content of the startphy.nc file depends on some flags defined in
+! the ".def" files. However, since conf_phys is not called in lmdz1d.F90, these flags have 
+! to be set at some arbitratry convenient values.
 !------------------------------------------------------------------------
 !Al1 =============== restart option ==========================
         if (.not.restart) then
+          iflag_pbl = 5
           call phyredem ("startphy.nc")
         else
@@ -1075,5 +1090,5 @@
 !---------------------------------------------------------------------
 
-      IF (nudge_tsoil) THEN
+      IF (nudge_tsoil .AND. .NOT. lastcall) THEN
        ftsoil(1,isoil_nudge,:) = ftsoil(1,isoil_nudge,:)                     &
      &  -timestep/tau_soil_nudge*(ftsoil(1,isoil_nudge,:)-Tsoil_nudge)
Index: /LMDZ5/branches/testing/libf/phylmd/grid_noro_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/grid_noro_m.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/grid_noro_m.F90	(revision 2594)
@@ -3,6 +3,8 @@
 !*******************************************************************************
 
+  USE print_control_mod, ONLY: lunout
+  USE assert_eq_m,       ONLY: assert_eq
   PRIVATE
-  PUBLIC :: grid_noro
+  PUBLIC :: grid_noro, grid_noro0
 
 
@@ -45,8 +47,5 @@
 !    on the edge are contained in input cells.
 !===============================================================================
-  USE assert_eq_m, ONLY: assert_eq
-  USE print_control_mod, ONLY: lunout
-  IMPLICIT NONE 
-  REAL, PARAMETER :: epsfra = 1.e-5
+  IMPLICIT NONE
 !-------------------------------------------------------------------------------
 ! Arguments:
@@ -315,4 +314,147 @@
 !-------------------------------------------------------------------------------
 !
+SUBROUTINE grid_noro0(xd,yd,zd,x,y,zphi,mask)
+!
+!===============================================================================
+! Purpose: Extracted from grid_noro to provide geopotential height for dynamics
+!          without any call to physics subroutines.
+!===============================================================================
+  IMPLICIT NONE 
+!-------------------------------------------------------------------------------
+! Arguments:
+  REAL, INTENT(IN)   :: xd(:), yd(:) !--- INPUT  COORDINATES     (imdp) (jmdp)
+  REAL, INTENT(IN)   :: zd(:,:)      !--- INPUT  FIELD           (imdp,jmdp)
+  REAL, INTENT(IN)   :: x(:), y(:)   !--- OUTPUT COORDINATES     (imar+1) (jmar)
+  REAL, INTENT(OUT)  :: zphi(:,:)    !--- GEOPOTENTIAL           (imar+1,jmar)
+  REAL, INTENT(INOUT):: mask(:,:)    !--- MASK                   (imar+1,jmar)
+!-------------------------------------------------------------------------------
+! Local variables:
+  CHARACTER(LEN=256) :: modname="grid_noro0"
+  REAL, ALLOCATABLE :: xusn(:), yusn(:)           ! dim (imdp+2*iext) (jmdp+2)
+  REAL, ALLOCATABLE :: zusn(:,:)                  ! dim (imdp+2*iext,jmdp+2)
+  REAL, ALLOCATABLE :: weight(:,:)                ! dim (imar+1,jmar)
+  REAL, ALLOCATABLE :: mask_tmp(:,:), zmea(:,:)   ! dim (imar+1,jmar)
+  REAL, ALLOCATABLE :: num_tot(:,:), num_lan(:,:) ! dim (imax,jmax)
+  REAL, ALLOCATABLE :: a(:), b(:)                 ! dim (imax)
+  REAL, ALLOCATABLE :: c(:), d(:)                 ! dim (jmax)
+  LOGICAL :: masque_lu
+  INTEGER :: i, ii, imdp, imar, iext
+  INTEGER :: j, jj, jmdp, jmar, nn
+  REAL    :: xpi, zlenx, weighx, xincr,  zbordnor, zmeanor, zweinor, zbordest
+  REAL    :: rad, zleny, weighy, masque, zbordsud, zmeasud, zweisud, zbordoue
+!-------------------------------------------------------------------------------
+  imdp=assert_eq(SIZE(xd),SIZE(zd,1),TRIM(modname)//" imdp")
+  jmdp=assert_eq(SIZE(yd),SIZE(zd,2),TRIM(modname)//" jmdp")
+  imar=assert_eq(SIZE(x),SIZE(zphi,1),SIZE(mask,1),TRIM(modname)//" imar")-1
+  jmar=assert_eq(SIZE(y),SIZE(zphi,2),SIZE(mask,2),TRIM(modname)//" jmar")
+! IF(imar/=iim)   CALL abort_gcm(TRIM(modname),'imar/=iim'  ,1)
+! IF(jmar/=jjm+1) CALL abort_gcm(TRIM(modname),'jmar/=jjm+1',1)
+  iext=imdp/10
+  xpi = ACOS(-1.)
+  rad = 6371229.
+
+!--- ARE WE USING A READ MASK ?
+  masque_lu=ANY(mask/=-99999.); IF(.NOT.masque_lu) mask=0.0
+  WRITE(lunout,*)'Masque lu: ',masque_lu
+
+!--- EXTENSION OF THE INPUT DATABASE TO PROCEED COMPUTATIONS AT BOUNDARIES:
+  ALLOCATE(xusn(imdp+2*iext))
+  xusn(1     +iext:imdp  +iext)=xd(:)
+  xusn(1          :       iext)=xd(1+imdp-iext:imdp)-2.*xpi
+  xusn(1+imdp+iext:imdp+2*iext)=xd(1          :iext)+2.*xpi
+
+  ALLOCATE(yusn(jmdp+2))
+  yusn(1       )=yd(1)   +(yd(1)   -yd(2))
+  yusn(2:jmdp+1)=yd(:)
+  yusn(  jmdp+2)=yd(jmdp)+(yd(jmdp)-yd(jmdp-1))
+
+  ALLOCATE(zusn(imdp+2*iext,jmdp+2))
+  zusn(1       +iext:imdp  +iext,2:jmdp+1)=zd  (:                   ,     :)
+  zusn(1            :       iext,2:jmdp+1)=zd  (imdp-iext+1:imdp    ,     :)
+  zusn(1+imdp  +iext:imdp+2*iext,2:jmdp+1)=zd  (1:iext              ,     :)
+  zusn(1            :imdp/2+iext,       1)=zusn(1+imdp/2:imdp  +iext,     2)
+  zusn(1+imdp/2+iext:imdp+2*iext,       1)=zusn(1       :imdp/2+iext,     2)
+  zusn(1            :imdp/2+iext,  jmdp+2)=zusn(1+imdp/2:imdp  +iext,jmdp+1)
+  zusn(1+imdp/2+iext:imdp+2*iext,  jmdp+2)=zusn(1       :imdp/2+iext,jmdp+1)
+
+!--- COMPUTE LIMITS OF MODEL GRIDPOINT AREA (REGULAR GRID)
+  ALLOCATE(a(imar+1),b(imar+1))
+  b(1:imar)=(x(1:imar  )+ x(2:imar+1))/2.0
+  b(imar+1)= x(  imar+1)+(x(  imar+1)-x(imar))/2.0
+  a(1)=x(1)-(x(2)-x(1))/2.0
+  a(2:imar+1)= b(1:imar)
+
+  ALLOCATE(c(jmar),d(jmar))
+  d(1:jmar-1)=(y(1:jmar-1)+ y(2:jmar))/2.0
+  d(  jmar  )= y(  jmar  )+(y(  jmar)-y(jmar-1))/2.0
+  c(1)=y(1)-(y(2)-y(1))/2.0
+  c(2:jmar)=d(1:jmar-1)
+
+!--- INITIALIZATIONS:
+  ALLOCATE(weight(imar+1,jmar)); weight(:,:)= 0.0
+  ALLOCATE(zmea  (imar+1,jmar)); zmea  (:,:)= 0.0
+
+!--- SUMMATION OVER GRIDPOINT AREA
+  zleny=xpi/REAL(jmdp)*rad
+  xincr=xpi/REAL(jmdp)/2.
+  ALLOCATE(num_tot(imar+1,jmar)); num_tot(:,:)=0.
+  ALLOCATE(num_lan(imar+1,jmar)); num_lan(:,:)=0.
+  DO ii = 1, imar+1
+    DO jj = 1, jmar
+      DO j = 2,jmdp+1 
+        zlenx  =zleny  *COS(yusn(j))
+        zbordnor=(xincr+c(jj)-yusn(j))*rad
+        zbordsud=(xincr-d(jj)+yusn(j))*rad
+        weighy=AMAX1(0.,AMIN1(zbordnor,zbordsud,zleny))
+        IF(weighy/=0) THEN
+          DO i = 2, imdp+2*iext-1
+            zbordest=(xusn(i)-a(ii)+xincr)*rad*COS(yusn(j))
+            zbordoue=(b(ii)+xincr-xusn(i))*rad*COS(yusn(j))
+            weighx=AMAX1(0.,AMIN1(zbordest,zbordoue,zlenx))
+            IF(weighx/=0)THEN
+              num_tot(ii,jj)=num_tot(ii,jj)+1.0
+              IF(zusn(i,j)>=1.)num_lan(ii,jj)=num_lan(ii,jj)+1.0
+              weight(ii,jj)=weight(ii,jj)+weighx*weighy
+              zmea  (ii,jj)=zmea  (ii,jj)+zusn(i,j)*weighx*weighy !--- MEAN
+            END IF
+          END DO
+        END IF
+      END DO
+    END DO
+  END DO
+
+!--- COMPUTE PARAMETERS NEEDED BY LOTT & MILLER (1997) AND LOTT (1999) SSO SCHEME
+  IF(.NOT.masque_lu) THEN
+    WHERE(weight(:,1:jmar-1)/=0.0) mask=num_lan(:,:)/num_tot(:,:)
+  END IF
+  nn=COUNT(weight(:,1:jmar-1)==0.0)
+  IF(nn/=0) WRITE(lunout,*)'Problem with weight ; vanishing occurrences: ',nn
+  WHERE(weight/=0.0) zmea(:,:)=zmea(:,:)/weight(:,:)
+
+!--- MASK BASED ON GROUND MAXIMUM, 10% THRESHOLD (<10%: SURF PARAMS MEANINGLESS)
+  ALLOCATE(mask_tmp(imar+1,jmar)); mask_tmp(:,:)=0.0
+  WHERE(mask>=0.1) mask_tmp = 1.
+  WHERE(weight(:,:)/=0.0)
+    zphi(:,:)=mask_tmp(:,:)*zmea(:,:)
+    zmea(:,:)=mask_tmp(:,:)*zmea(:,:)
+  END WHERE
+  WRITE(lunout,*)'  MEAN ORO:' ,MAXVAL(zmea)
+
+!--- Values at poles
+  zphi(imar+1,:)=zphi(1,:)
+
+  zweinor=SUM(weight(1:imar,   1),DIM=1)
+  zweisud=SUM(weight(1:imar,jmar),DIM=1)
+  zmeanor=SUM(weight(1:imar,   1)*zmea(1:imar,   1),DIM=1)
+  zmeasud=SUM(weight(1:imar,jmar)*zmea(1:imar,jmar),DIM=1)
+  zphi(:,1)=zmeanor/zweinor; zphi(:,jmar)=zmeasud/zweisud
+
+END SUBROUTINE grid_noro0
+!
+!-------------------------------------------------------------------------------
+
+
+!-------------------------------------------------------------------------------
+!
 SUBROUTINE MVA9(x)
 !
Index: /LMDZ5/branches/testing/libf/phylmd/nuage.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/nuage.h	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/nuage.h	(revision 2594)
@@ -9,9 +9,10 @@
       REAL tmax_fonte_cv
 
-      INTEGER iflag_t_glace,iflag_cld_cv
+      INTEGER iflag_t_glace, iflag_cloudth_vert, iflag_cld_cv
 
       common /nuagecom/ rad_froid,rad_chau1, rad_chau2,t_glace_max,     &
      &                  t_glace_min,exposant_glace,rei_min,rei_max,     &
      &                  tau_cld_cv,coefw_cld_cv,                        &
-     &                  iflag_t_glace,iflag_cld_cv,tmax_fonte_cv
+     &                  iflag_t_glace,iflag_cloudth_vert,iflag_cld_cv,  &
+     &                  tmax_fonte_cv
 !$OMP THREADPRIVATE(/nuagecom/)
Index: /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2594)
@@ -18,5 +18,5 @@
        wake_deltat, wake_delta_pbl_TKE, delta_tsurf, wake_fip, wake_pe, &
        wake_s, zgam, zmax0, zmea, zpic, zsig, &
-       zstd, zthe, zval, ale_bl, ale_bl_trig, alp_bl
+       zstd, zthe, zval, ale_bl, ale_bl_trig, alp_bl, u10m, v10m
   USE geometry_mod, ONLY : longitude_deg, latitude_deg
   USE iostart, ONLY : close_startphy, get_field, get_var, open_startphy
@@ -260,6 +260,7 @@
   ENDDO
 
-
-  
+  found=phyetat0_srf(1,u10m,"U10M","u a 10m",0.)
+  found=phyetat0_srf(1,v10m,"V10M","v a 10m",0.)
+
 !===================================================================
   ! Lecture des temperatures du sol profond:
Index: /LMDZ5/branches/testing/libf/phylmd/phyredem.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2594)
@@ -21,5 +21,5 @@
                                 wake_pe, wake_fip, fm_therm, entr_therm,     &
                                 detr_therm, Ale_bl, Ale_bl_trig, Alp_bl,     &
-                                du_gwd_rando, du_gwd_front
+                                du_gwd_rando, du_gwd_front, u10m, v10m
   USE geometry_mod, ONLY : longitude_deg, latitude_deg
   USE iostart, ONLY: open_restartphy, close_restartphy, put_field, put_var
@@ -153,4 +153,9 @@
 
   
+  CALL put_field_srf1("U10M", "u a 10m", u10m)
+
+  CALL put_field_srf1("V10M", "v a 10m", v10m)
+
+
 ! ================== Tsoil =========================================
   CALL put_field_srf2("Tsoil","Temperature",tsoil(:,:,:))
Index: /LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 2593)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 2594)
@@ -16,4 +16,6 @@
       REAL, SAVE, ALLOCATABLE :: u_seri(:,:), v_seri(:,:)
       !$OMP THREADPRIVATE(u_seri, v_seri)
+      REAL, SAVE, ALLOCATABLE :: l_mixmin(:,:,:), l_mix(:,:,:)
+      !$OMP THREADPRIVATE(l_mixmin, l_mix)
 
       REAL, SAVE, ALLOCATABLE :: tr_seri(:,:,:)
@@ -406,4 +408,6 @@
       allocate(t_seri(klon,klev),q_seri(klon,klev),ql_seri(klon,klev),qs_seri(klon,klev))
       allocate(u_seri(klon,klev),v_seri(klon,klev))
+      allocate(l_mixmin(klon,klev,nbsrf), l_mix(klon,klev,nbsrf))
+      l_mix(:,:,:)=0. ; l_mixmin(:,:,:)=0. ! doit etre initialse car pas toujours remplis
 
       allocate(tr_seri(klon,klev,nbtr))
@@ -625,4 +629,5 @@
       deallocate(t_seri,q_seri,ql_seri,qs_seri)
       deallocate(u_seri,v_seri)
+      deallocate(l_mixmin,l_mix)
 
       deallocate(tr_seri)
